﻿using System;
using System.Collections.Generic;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using Microsoft.Win32;
using System.IO;
//using Infragistics.Excel;
using System.Diagnostics.CodeAnalysis;
using System.Diagnostics;
using Infragistics.Documents.Excel;
using Infragistics.Windows.DataPresenter.ExcelExporter;

namespace XamDataGridExportData
{   
    public partial class MainWindow : Window
    {
        private UpdateMultipleLogFieldCol _updateMultipleLogFieldCol;
        private int excelWorksheetCounter;
        private bool IsActualPositionExist = true;

        private Workbook excelWorkbook;
        private Worksheet excelWorksheet;        

        /// <summary>
        /// 
        /// </summary>
        public UpdateMultipleLogFieldCol UpdateMultipleLogFieldColList
        {
            get { return _updateMultipleLogFieldCol; }
            set { _updateMultipleLogFieldCol = value; }
        }

        public MainWindow()
        {
            InitializeComponent();
            SetGridProperties();
            LoadDataToGrid();
        }

        private void SetGridProperties()
        {
            UpdateMultipleLogGrid.GroupByArea.Visibility = Visibility.Collapsed;
            UpdateMultipleLogGrid.FieldSettings.AllowEdit = false;
            UpdateMultipleLogGrid.FieldLayoutSettings.AutoGenerateFields = true;  
            UpdateMultipleLogGrid.FieldSettings.CellClickAction = CellClickAction.SelectRecord;
            UpdateMultipleLogGrid.ScrollingMode = ScrollingMode.Immediate;
            UpdateMultipleLogGrid.FieldSettings.LabelClickAction = LabelClickAction.SortByOneFieldOnly;
        }

        private void LoadDataToGrid()
        {
            InitializeLayout();
            excelWorksheetCounter = 0;
            excelWorkbook = new Workbook();
            excelWorksheet = excelWorkbook.Worksheets.Add("XamDataGridWorkSheet1");

            LoadData();
            UpdateMultipleLogGrid.DataSource = null;

           UpdateMultipleLogGrid.DataSource = UpdateMultipleLogFieldColList;
           UpdateMultipleLogGrid.FieldSettings.AllowGroupBy = true;
        }

        private void InitializeLayout()
        {
            UpdateMultipleLogGrid.DataSource = null;

            FieldLayout fieldLayout = new FieldLayout();
            fieldLayout.Fields.Add(FillGrid("ClientID", "ClientID", 300, 155, true, false, Visibility.Visible, true));
            fieldLayout.Fields.Add(FillGrid("ClientSubID", "ClientSubID", 300, 160, true, false, Visibility.Visible, true));
            fieldLayout.Fields.Add(FillGrid("ClientName", "ClientSortName", 400, 160, true, false, Visibility.Visible, true));
            fieldLayout.Fields.Add(FillGrid("Status", "Status", 400, 100, true, false, Visibility.Visible, true));
            fieldLayout.Fields.Add(FillGrid("Comments", "Comments", 650, 650, true, false, Visibility.Collapsed, true));
            fieldLayout.Fields.Add(FillGrid("ClientGUID", "ClientGUIDComments", 650, 650, true, false, Visibility.Collapsed, true));

            UpdateMultipleLogGrid.Height = 298;
            UpdateMultipleLogGrid.VerticalAlignment = System.Windows.VerticalAlignment.Top;

            UpdateMultipleLogGrid.FieldLayouts.Clear();
            UpdateMultipleLogGrid.FieldLayouts.Add(fieldLayout);

            FieldLayout fieldLayout1 = new FieldLayout();
            fieldLayout1.Fields.Add(FillGrid("LogFieldName", "FieldName", 300, 165, true, false, Visibility.Visible, true));
            fieldLayout1.Fields.Add(FillGrid("LogFieldStatus", "FieldStatus", 650, 450, true, false, Visibility.Visible, true));
            UpdateMultipleLogGrid.FieldLayouts.Add(fieldLayout1);
        }

        private Field FillGrid(string fieldName, string labelName, int cellMaxWidth, int cellWidth,
                    bool allowResize, bool allowEdit, Visibility objVisibility, bool isExpandable)
        {
            Field objField = new Field();
            objField.Name = fieldName;
            objField.Label = labelName;
            objField.Settings.AllowResize = allowResize;
            objField.Settings.AllowEdit = allowEdit;
            objField.Settings.CellMaxWidth = cellMaxWidth;
            objField.Settings.CellWidth = cellWidth;
            objField.IsExpandable = !isExpandable;           
            return objField;
        }

        private Field FillGrid(string fieldName, string labelName, int cellMaxWidth, int cellWidth,
                    bool allowResize, bool allowEdit, Visibility objVisibility, bool isExpandable, FieldPosition actualPosition)
        {
            Field objField = new Field();
            objField.Name = fieldName;
            objField.Label = labelName;
            objField.Settings.AllowResize = allowResize;
            objField.Settings.AllowEdit = allowEdit;
            objField.Settings.CellMaxWidth = cellMaxWidth;
            objField.Settings.CellWidth = cellWidth;
            objField.IsExpandable = !isExpandable;
            objField.ActualPosition = actualPosition;
            return objField;
        }

        void LoadData()
        {
            try
            {
                _updateMultipleLogFieldCol = new UpdateMultipleLogFieldCol(); 
                UpdateMultipleLogField updateMultipleLogField0 = new UpdateMultipleLogField();
                updateMultipleLogField0.ClientGUID = new Guid("ab95d561-9af6-4e2e-8b56-11ea0bcae490");
                updateMultipleLogField0.ClientID = "040215";
                updateMultipleLogField0.ClientName = "manasfd, chase";
                updateMultipleLogField0.ClientSubID = "Sub";
                updateMultipleLogField0.Comments = null ;
                updateMultipleLogField0.Status = "Successful";
                LogField LogField1 = new LogField("Class", "Updated Successfully");
                LogField LogField2 = new LogField("Line of business", "Updated Successfully");
                updateMultipleLogField0.LogFieldList.Add(LogField1);
                updateMultipleLogField0.LogFieldList.Add(LogField2);
                _updateMultipleLogFieldCol.Add(updateMultipleLogField0);

                UpdateMultipleLogField updateMultipleLogField1 = new UpdateMultipleLogField();
                updateMultipleLogField1.ClientGUID = new Guid("c1b765ac-8a14-4178-8fce-dba0f29efb6e");
                updateMultipleLogField1.ClientID = "040216";
                updateMultipleLogField1.ClientName = "manhatton, chase";
                updateMultipleLogField1.ClientSubID = "Sub1";
                updateMultipleLogField1.Comments = null;
                updateMultipleLogField1.Status = "Successful";
                LogField LogField3 = new LogField("Class", "Updated Successfully");
                LogField LogField4 = new LogField("Line of business", "Updated Successfully");
                updateMultipleLogField1.LogFieldList.Add(LogField3);
                updateMultipleLogField1.LogFieldList.Add(LogField4);
                _updateMultipleLogFieldCol.Add(updateMultipleLogField1);
            }
            catch(Exception ex)
            {

            }
        }

        private void btnExport_Click(object sender, RoutedEventArgs e)
        {
            //exporting to excel
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.Export(this.UpdateMultipleLogGrid, "xamDataPresenter1.xlsx", WorkbookFormat.Excel2007);
        }

        private void btnClose_Click(object sender, RoutedEventArgs e)
        {
            this.Close();            
        }

       //  #region Export to Excel
       // /// <summary>
       // /// Exports to excel.
       // /// </summary>
       // /// <param name="data">The data.</param>

       // public void ExportToExcel(object data)
       // {
       //     string reportPath = string.Empty;
       //     SaveFileDialog savedialog = new SaveFileDialog();
       //     savedialog.Filter = "Microsoft Office Excel Workbook(.xls)|*.xls|PDF Document(.pdf)|*.pdf|XPS Document(.xps)|*.xps";
       //     savedialog.FileName = "Default123";
       //     Nullable<bool> result = savedialog.ShowDialog();
       //     if (result == true)
       //     {
       //         if (savedialog.FilterIndex == 1)
       //         {
       //             reportPath = OnExportToExcel(data, savedialog.FileName);
       //             if (!string.IsNullOrEmpty(reportPath))
       //             {
       //                 StartProcess(reportPath);
       //             }
       //         }
       //     }
       // }

       // [SuppressMessage("Microsoft.Design", "CA1031:DoNotCatchGeneralExceptionTypes")]
       // private void StartProcess(string path)
       // {
       //     try
       //     {
       //         Process process = new Process();
       //         process.StartInfo.FileName = path;
       //         bool started = process.Start();
       //         if (started)
       //             process.WaitForInputIdle();
       //     }
       //     catch (Exception ex)
       //     {
               
       //     }

       // }

       // private string OnExportToExcel(object data, string path)
       // {
       //     DataPresenterBase grid = data as DataPresenterBase;
       //     if (grid != null)
       //     {
       //         try
       //         {
       //             if (string.IsNullOrEmpty(path))
       //             {
       //                 string basePath = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData);
       //                 path = GetFileName(basePath, "Report", 0, ".xls");
       //             }
       //             FileInfo fileinfo = new FileInfo(path);
       //             if (fileinfo.Extension != ".xls")
       //             {
       //                 path = path + ".xls";
       //             }
       //             Export(grid, path);

       //         }

       //         catch (Exception)
       //         {  
       //             path = string.Empty;
       //         }
       //     }
       //     return path;
       // }

       // public void Export(DataPresenterBase xamDataGrid, string FileName)
       // {
       //     string[] fileExt = FileName.Split('\\');
       //     int ind = fileExt.Length;
       //     string fileName = fileExt[ind - 1];
       //     int indFileName = fileName.IndexOf('.');
       //     string fileExtension = fileName.Substring(indFileName);

       //     if (!string.IsNullOrEmpty(fileExtension))
       //     {
       //         if (fileExtension.Contains(".xlsx"))
       //             excelWorkbook.SetCurrentFormat(WorkbookFormat.Excel2007);
       //         else
       //             excelWorkbook.SetCurrentFormat(WorkbookFormat.Excel97To2003);

       //     }
       //     ExportXamDataGridRecords(xamDataGrid.Records);
       //     excelWorkbook.Save(FileName);
       //     excelWorksheetCounter = 0;

       // }

       // private void ExportXamDataGridRecords(RecordCollectionBase records)
       // {
       //     if (null == records)
       //         return;
       //     foreach (Record record in records)
       //     {
       //         DataRecord dr = record as DataRecord;
       //         if (dr != null && record.Index == 0)
       //             MakeWorkSheetHeaderRow(record);

       //         MakeWorkSheetRow(record);

       //         if (record.HasChildren)
       //         {
       //             if (dr != null)
       //                 ExportXamDataGridRecords(dr.ChildRecords[dr.ChildRecords.Count - 1].ChildRecords as RecordCollectionBase);
       //             else
       //             {
       //                 GroupByRecord groupByRecord = record as GroupByRecord;
       //                 ExportXamDataGridRecords(groupByRecord.ChildRecords);
       //             }
       //         }
       //     }
       // }

       // private WorksheetRow MakeWorkSheetHeaderRow(Record record)
       // {
       //     int level = GetHierarchichalLevel(record);
       //     WorksheetRow excelWorkSheetRow = excelWorksheet.Rows[excelWorksheetCounter];

       //     excelWorkSheetRow.OutlineLevel = level;
       //     if (level == 0)
       //     {
       //         excelWorkSheetRow.Hidden = false;
       //     }
       //     else
       //     {
       //         if (record.ParentRecord.GetType() == typeof(GroupByRecord))
       //             excelWorkSheetRow.Hidden = !record.ParentRecord.IsExpanded;
       //         else
       //             excelWorkSheetRow.Hidden = !record.ParentDataRecord.IsExpanded;

       //     }
                        
       //     for (int i = 0; i < record.FieldLayout.Fields.Count; i++)
       //     {
       //         if (record.FieldLayout.Fields[i].IsExpandableResolved != true && record.FieldLayout.Fields[i].Visibility == Visibility.Visible)
       //         {                    
       //             excelWorkSheetRow = FormatHeaderCells(excelWorkSheetRow, level, i);
       //            if (!record.FieldLayout.Fields[i].Label.ToString().ToLower().Contains("guid"))
       //             {
       //                 //Hierarchical child rows fields actualPosition problem : if grid is not expanded then ActualPosition.Column for all fields shows 0
       //                 excelWorkSheetRow.Cells[record.FieldLayout.Fields[i].ActualPosition.Column + level].Value = record.FieldLayout.Fields[i].Label.ToString();
       //             }

       //         }

       //     }
       //     excelWorksheetCounter++;
       //     return excelWorkSheetRow;
       // }

       // private WorksheetRow FormatHeaderCells(WorksheetRow excelWorkSheetRow, int level, int i)
       // {
       //     excelWorkSheetRow.Cells[i + level].CellFormat.FillPatternForegroundColor = System.Drawing.Color.LightGray;
       //     excelWorkSheetRow.Cells[i + level].CellFormat.FillPattern = FillPatternStyle.Solid;

       //     return excelWorkSheetRow;
       // }

       // private WorksheetRow MakeWorkSheetRow(Record record)
       // {
       //     int level = GetHierarchichalLevel(record);
       //     DataRecord dataRecord = record as DataRecord;
       //     GroupByRecord groupByRecord = record as GroupByRecord;

       //     WorksheetRow excelWorkSheetRow = excelWorksheet.Rows[excelWorksheetCounter];

       //     if (record != null && level > 0)
       //     {

       //         if (record.ParentRecord.GetType() == typeof(GroupByRecord))
       //         {
       //             excelWorkSheetRow.Hidden = !record.ParentRecord.IsExpanded;
       //         }
       //         else
       //         {
       //             excelWorkSheetRow.Hidden = !record.ParentDataRecord.IsExpanded;
       //         }
       //         excelWorkSheetRow.OutlineLevel = level;
       //     }

       //     if (record.GetType() == typeof(DataRecord) && dataRecord != null)
       //     {
       //         for (int i = 0; i < dataRecord.Cells.Count; i++)
       //         {
       //             if (dataRecord.Cells[i].Value == null && dataRecord.Cells[i].Field.IsExpandableResolved != true && dataRecord.Cells[i].Field.Visibility == Visibility.Visible)
       //             {
       //                 if (IsActualPositionExist)
       //                 {
       //                     excelWorkSheetRow.Cells[dataRecord.Cells[i].Field.ActualPosition.Column + level].Value = dataRecord.Cells[i].Value;
       //                     excelWorkSheetRow.Cells[dataRecord.Cells[i].Field.ActualPosition.Column + level].CellFormat.WrapText = ExcelDefaultableBoolean.True;
       //                 }
       //                 else
       //                 {
       //                     excelWorkSheetRow.Cells[i].Value = dataRecord.Cells[i].Value;
       //                     excelWorkSheetRow.Cells[i].CellFormat.WrapText = ExcelDefaultableBoolean.True;
       //                 }
       //             }
       //             else if (dataRecord.Cells[i].Field.IsExpandableResolved != true && dataRecord.Cells[i].Field.Visibility == Visibility.Visible && dataRecord.Cells[i].Value.GetType() != typeof(Guid))
       //             {
       //                 if (IsActualPositionExist)
       //                 {
       //                     excelWorkSheetRow.Cells[dataRecord.Cells[i].Field.ActualPosition.Column + level].Value = dataRecord.Cells[i].Value;
       //                     excelWorkSheetRow.Cells[dataRecord.Cells[i].Field.ActualPosition.Column + level].CellFormat.WrapText = ExcelDefaultableBoolean.True;
       //                 }
       //                 else
       //                 {
       //                     excelWorkSheetRow.Cells[i].Value = dataRecord.Cells[i].Value;
       //                     excelWorkSheetRow.Cells[i].CellFormat.WrapText = ExcelDefaultableBoolean.True;
       //                 }

       //             }
       //         }
       //     }
       //     else
       //     {
       //         excelWorkSheetRow.Cells[0 + level].Value = groupByRecord.Description;
       //         for (int i = 0; i < groupByRecord.ChildRecords[0].FieldLayout.Fields.Count; i++)
       //         {
       //             FormatGroupByRecordCells(excelWorkSheetRow, level, i);
       //         }
       //     }
       //     excelWorksheetCounter++;
       //     return excelWorkSheetRow;

       // }

       // private WorksheetRow FormatGroupByRecordCells(WorksheetRow excelWorkSheetRow, int level, int i)
       // {
       //     excelWorkSheetRow.Cells[i + level].CellFormat.BottomBorderColor = System.Drawing.Color.Black;
       //     excelWorkSheetRow.Cells[i + level].CellFormat.LeftBorderColor = System.Drawing.Color.LightBlue;
       //     excelWorkSheetRow.Cells[i + level].CellFormat.BottomBorderStyle = CellBorderLineStyle.Medium;
       //     excelWorkSheetRow.Cells[i + level].CellFormat.FillPatternForegroundColor = System.Drawing.Color.LightBlue;
       //     excelWorkSheetRow.Cells[i + level].CellFormat.FillPattern = FillPatternStyle.Solid;
       //     return excelWorkSheetRow;
       // }

       // private int GetHierarchichalLevel(Record record)
       // {
       //     int level = 0;
       //     while (record.ParentDataRecord != null || record.ParentRecord != null)
       //     {
       //         if (record.ParentRecord.GetType() == typeof(GroupByRecord))
       //         {
       //             level++;
       //             record = record.ParentRecord;
       //         }
       //         else
       //         {
       //             level++;
       //             record = record.ParentDataRecord as Record;
       //         }
       //     }
       //     return level;
       // }

       // private string GetFileName(string basePath, string fileName, int counter, string extn)
       // {
       //     string fullPath = basePath + "\\" + fileName;
       //     string returnVal = string.Empty;
       //     if (counter > 0)
       //     {
       //         fullPath = basePath + "\\" + fileName + "(" + counter.ToString() + ")";
       //     }

       //     if (File.Exists(fullPath + extn))
       //     {
       //         returnVal = GetFileName(basePath, fileName, ++counter, extn);
       //     }
       //     else
       //     {
       //         returnVal = fullPath + extn;
       //     }
       //     return returnVal;
       // }
       //#endregion
    }

    #region DataTemplate    
    public class UpdateMultipleLogFieldCol : List<UpdateMultipleLogField>, IDisposable
    {
        private bool _disposed;
        #region IDisposable Members

        /// <summary>
        /// Dispose method
        /// </summary>
        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (!_disposed)
            {
                if (disposing)
                {
                    foreach (UpdateMultipleLogField updateMultipleLogField in this)
                    {
                        updateMultipleLogField.Dispose();
                    }
                }
                _disposed = true;
            }
        }

        #endregion
    }
       
    public class UpdateMultipleLogField : IDisposable
    {
        private bool _disposed;

        private string _clientID;

        /// <summary>
        /// Sets Client ID for Log Dialog Grid 
        /// </summary>
        public string ClientID
        {
            get { return _clientID; }
            set { _clientID = value; }
        }

        private Guid _clientGUID;

        /// <summary>
        /// Sets Client GUID for Log Dialog Grid 
        /// </summary>
        public Guid ClientGUID
        {
            get { return _clientGUID; }
            set { _clientGUID = value; }
        }

        private string _clientSubID;

        /// <summary>
        /// Sets Client Sub ID for Log Dialog Grid 
        /// </summary>
        public string ClientSubID
        {
            get { return _clientSubID; }
            set { _clientSubID = value; }
        }

        private string _clientName;

        /// <summary>
        /// Sets Client Name for Log Dialog Grid 
        /// </summary>
        public string ClientName
        {
            get { return _clientName; }
            set { _clientName = value; }
        }

        private string _status;

        /// <summary>
        /// Sets Status field for Log Dialog Grid 
        /// </summary>
        public string Status
        {
            get { return _status; }
            set { _status = value; }
        }

        private string _comments;

        /// <summary>
        /// Sets comments field for Log Dialog Grid 
        /// </summary>
        public string Comments
        {
            get { return _comments; }
            set { _comments = value; }
        }

        public List<LogField> _logFieldList = new List<LogField>();

        /// <summary>
        /// Sets Field List for Log Dialog Grid 
        /// </summary>
        public List<LogField> LogFieldList
        {
            get { return _logFieldList; }
            set { _logFieldList = value; }
        }

        #region IDisposable Members

        /// <summary>
        /// Dispose method
        /// </summary>
        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (!_disposed)
            {
                if (disposing)
                {
                    _clientID = null;
                    _clientSubID = null;
                    _clientName = null;
                    _status = null;
                    _comments = null;
                }
                _disposed = true;
            }
        }

        #endregion
    }

    [Serializable]
    public class LogField
    {
        private string _logFieldName;

        /// <summary>
        /// Sets Field Name for Log Dialog Grid 
        /// </summary>
        public string LogFieldName
        {
            get { return _logFieldName; }
            set { _logFieldName = value; }
        }

        private string _LogFieldStatus;

        /// <summary>
        /// Sets Field Status for Log Dialog Grid 
        /// </summary>
        public string LogFieldStatus
        {
            get { return _LogFieldStatus; }
            set { _LogFieldStatus = value; }
        }

        public LogField()
        {
        }
        public LogField(string logFieldName, string logFieldStatus)
        {
            _logFieldName = logFieldName;
            _LogFieldStatus = logFieldStatus;
        }
    }
    #endregion
}
